﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;
using Infragistics.Win.UltraWinCalcManager;

namespace FunWithSummaries
{
    public partial class Form1 : Form
    {
        DataTable table;

        public Form1()
        {
            InitializeComponent();
            this.StartPosition = FormStartPosition.CenterScreen;
            this.Text = "Fun with Summaries";
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            ultraGrid1.DataSource = BuildTable(table);
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            ultraGrid1.Font = new Font("Microsoft Sans Serif", 10.25F);
            UltraGridLayout layout = e.Layout;
            UltraGridBand band = layout.Bands[0];
            layout.GroupByBox.Hidden = true;
            layout.Override.ActiveRowAppearance.BackColor = Color.Brown;
            layout.Override.HeaderAppearance.BackColor = Color.LightBlue;
            layout.Override.HeaderStyle = Infragistics.Win.HeaderStyle.Standard;
            layout.Override.HeaderAppearance.FontData.Bold = Infragistics.Win.DefaultableBoolean.True;
            layout.Override.RowSelectors = DefaultableBoolean.True;
            band.Columns.Add("Field 3");
            band.Columns["Field 3"].Formula = "[Field 1] / [Field 2]";

            band.SummaryFooterCaption = "";
            band.Summaries.Add("Summary1",
               SummaryType.Sum, band.Columns["Field 1"],
               SummaryPosition.UseSummaryPositionColumn);
            band.Summaries.Add("Summary2",
               SummaryType.Sum, band.Columns["Field 2"],
               SummaryPosition.UseSummaryPositionColumn);
            band.Summaries.Add("Summary3", "[Summary1()] / [Summary2()]", 
                SummaryPosition.UseSummaryPositionColumn, 
                band.Columns["Field 3"]);
              
            band.Summaries["Summary1"].DisplayFormat = "{0:#,###}";
            band.Summaries["Summary2"].DisplayFormat = "{0:#,###}";
            band.Summaries["Summary3"].DisplayFormat = "{0:#,###}";
        }

        private DataTable BuildTable(DataTable table)
        {
            table = new DataTable("Numbers");
            table.Columns.Add("Field 1", typeof(Int32));
            table.Columns.Add("Field 2", typeof(Int32));
            
            table.Rows.Add(new object[] { 10, 2 });
            table.Rows.Add(new object[] { 90, 3 });
           
            return table;
        }
    }
}
